local addon = MissionMinder:CreateAddon("MissionMinder-OrderHall")
local module = addon:CreateModule("listView")




---------------------------------------------
-- List view
---------------------------------------------





--[[

local function inprogressTooltips(missionInfo, showRewards)
	GameTooltip:SetText(missionInfo.name);
	-- level
	if ( missionInfo.level == GARRISON_FOLLOWER_MAX_LEVEL and missionInfo.iLevel > 0 ) then
		GameTooltip:AddLine(format(GARRISON_MISSION_LEVEL_ITEMLEVEL_TOOLTIP, missionInfo.level, missionInfo.iLevel), 1, 1, 1);
	else
		GameTooltip:AddLine(format(GARRISON_MISSION_LEVEL_TOOLTIP, missionInfo.level), 1, 1, 1);
	end

	-- time
	if ( MissionMinder.IsMissionComplete(missionInfo) ) then
		GameTooltip:AddLine("(" .. COMPLETE .. ")", 0, 1, 0)
	else
		GameTooltip:AddLine(tostring(missionInfo.timeLeft) .. " " .. RED_FONT_COLOR_CODE .. GARRISON_MISSION_IN_PROGRESS .. FONT_COLOR_CODE_CLOSE, 1, 1, 1);
	end

	--[===[@debug@
	GameTooltip:AddLine("MissionID = " .. missionInfo.missionID);
	--@end-debug@]===]

	if ( showRewards ) then
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(REWARDS);
		for id, reward in pairs(missionInfo.rewards) do
			if (reward.quality) then
				GameTooltip:AddLine(ITEM_QUALITY_COLORS[reward.quality + 1].hex..reward.title..FONT_COLOR_CODE_CLOSE);
			elseif (reward.itemID) then
				local itemName, _, itemRarity, _, _, _, _, _, _, itemTexture = GetItemInfo(reward.itemID);
				if itemName then
					GameTooltip:AddLine(ITEM_QUALITY_COLORS[itemRarity].hex..itemName..FONT_COLOR_CODE_CLOSE);
				end
			elseif (reward.followerXP) then
				GameTooltip:AddLine(reward.title, 1, 1, 1);
			else
				GameTooltip:AddLine(reward.title, 1, 1, 1);
			end
		end
	end

	if (missionInfo.followers ~= nil) then
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(GARRISON_FOLLOWERS);
		for i=1, #(missionInfo.followers) do
			GameTooltip:AddLine(C_Garrison.GetFollowerName(missionInfo.followers[i]), 1, 1, 1);
		end
	end
end

local function GetInProgressAndCompletedMissions(missions)
	C_Garrison.GetInProgressMissions(missions);

	if ( options.ListViewEnabled() ) then
		GarrisonMissionFrame.MissionComplete.completeMissions = C_Garrison.GetCompleteMissions();
		local completed = GarrisonMissionFrame.MissionComplete.completeMissions;

		-- Add completed mission to list
		for index = 1, #completed do
			local mission = completed[index];
			if ( mission.state == 0 ) then -- COMPLETED
				mission.inProgress = true;
				mission.timeLeft = ""; -- set to non-nil to avoid nil error in blizzard code
				missions[#missions + 1] = mission;
			end
		end
	end

	Garrison_SortMissions(missions);
end




local function missionList_OnUpdate(now, self)
	if (self.showInProgress) then
		GetInProgressAndCompletedMissions(self.inProgressMissions);
		self.Tab2:SetText(WINTERGRASP_IN_PROGRESS.." - "..#self.inProgressMissions)
		GarrisonMissionList_Update();
	else
		local now = GetTime();
		for i = 1, #self.availableMissions do
			if ( self.availableMissions[i].offerEndTime and self.availableMissions[i].offerEndTime <= now ) then
				GarrisonMissionList_UpdateMissions();
				break;
			end
		end
	end
end]]






--[[local function showMissionCompleteFrame(...)
	-- Do not popup mission complete dialog if the "In Progress" mission tab is already selected
	local self = GarrisonMissionFrame;
	if ( options.ListViewEnabled() ) then
		if( self:IsShown() and self.MissionTab.MissionList.showInProgress) then
			self.MissionComplete.completeMissions = C_Garrison.GetCompleteMissions();
			return;
		end
	end

	addon.GarrisonMissionFrame_CheckCompleteMissions(...)
end







local function selectAvailableMissions(...)
	GarrisonMissionList_SetTab(GarrisonMissionFrame.MissionTab.MissionList.Tab1);
end

local function refreshCompletedMissions()
	if ( options.ListViewEnabled() ) then
		local self = GarrisonMissionFrame.MissionComplete;
		self.completeMissions = C_Garrison.GetCompleteMissions();

		GetInProgressAndCompletedMissions(GarrisonMissionFrame.MissionTab.MissionList.inProgressMissions);
		GarrisonMissionList_Update();
	end
end

local function refreshCompletedMissionsForQuickLoot()
	if ( options.QuickLoot() ) then
		refreshCompletedMissions()
	end
end

function MissionMinder_MissionFollowerFrame_OnEnter(self)
	local follower = self.info
	local mission = self:GetParent().info
	if not follower or not mission then
		return;
	end

	GarrisonFollowerTooltip:ClearAllPoints();
	GarrisonFollowerTooltip:SetPoint("TOPLEFT", self, "BOTTOMRIGHT");
	GarrisonFollowerTooltip_Show(follower.garrFollowerID,
		follower.isCollected,
		C_Garrison.GetFollowerQuality(follower.followerID),
		C_Garrison.GetFollowerLevel(follower.followerID),
		C_Garrison.GetFollowerXP(follower.followerID),
		C_Garrison.GetFollowerLevelXP(follower.followerID),
		C_Garrison.GetFollowerItemLevelAverage(follower.followerID),
		C_Garrison.GetFollowerAbilityAtIndex(follower.followerID, 1),
		C_Garrison.GetFollowerAbilityAtIndex(follower.followerID, 2),
		C_Garrison.GetFollowerAbilityAtIndex(follower.followerID, 3),
		C_Garrison.GetFollowerAbilityAtIndex(follower.followerID, 4),
		C_Garrison.GetFollowerTraitAtIndex(follower.followerID, 1),
		C_Garrison.GetFollowerTraitAtIndex(follower.followerID, 2),
		C_Garrison.GetFollowerTraitAtIndex(follower.followerID, 3),
		C_Garrison.GetFollowerTraitAtIndex(follower.followerID, 4),
		true,
		C_Garrison.GetFollowerBiasForMission(mission.missionID, follower.followerID) < 0.0
		);
end]]


---------------------------------------------
-- INITIALIZE
---------------------------------------------
function module.initialize()
	local missionFrame =  OrderHallMissionFrame
	local missionList = missionFrame.MissionTab.MissionList

	-- "View Completed Missions" button will open "In Progress" tab instead of "CompleteMission" frame
	local viewButton = missionList.CompleteDialog.BorderFrame.ViewButton;
	viewButton.OriginalOnClick = viewButton:GetScript("OnClick")
	viewButton:SetScript("OnClick", MissionMinder_CompleteDialog_ShowInProgressMissionList);

	-- Override CompleteDialog initialize so we can target a specific mission
	--instead of defaulting to "first mission in list"
	missionFrame.OriginalOnClickViewCompletedMissionsButton = missionFrame.OnClickViewCompletedMissionsButton
	missionFrame.OnClickViewCompletedMissionsButton = MissionMinder_MissionFrame_ViewSpecificCompletedMission

	-- Completed Missions that haven't been looted are not considered "in progress" anymore
	--and need to be added to the list
	missionList.UpdateMissions = MissionMinder_InProgressMissionList_IncludeCompletedMissions
	missionList.OnUpdate = missionListOnUpdate_IncludeCompletedMissions
	missionList:SetScript("OnUpdate", missionList.OnUpdate)

	-- Sort InProgress missions by completed first
	Garrison_SortMissions = function(missions)
		table.sort(missions, MissionMinder_CompletedMissionsSortComparator);
	end

	-- Highlight completed missions
	hooksecurefunc(missionList, "Update", MissionMinder_InProgressMissionList_HighlightCompletedMissions);
	--GarrisonMissionFrame.MissionTab.MissionList.listScroll.update = GarrisonMissionList_Update; -- Set the update method to the new hooked method

	-- Clicking a completed mission will view it
	local missionButtons = missionList.listScroll.buttons;
	for i = 1, #missionButtons do
		local button = missionButtons[i];
		button:HookScript("OnClick", MissionMinder_InProgressMissionList_ViewMission);
	end

	-- Show special tooltips for completed missions
	--[[GarrisonMissionButton_SetInProgressTooltip = inprogressTooltips]]

	-- Create SuccessChance text
	for i = 1, #missionButtons do
		local button = missionButtons[i];
		local successChance = button:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
		successChance:SetPoint("TOPLEFT", button.Title, "BOTTOMLEFT", 0, -17);
		successChance:SetTextColor(0, 1, 0);
		successChance:SetSize(115, 15)
		button.SuccessChance = successChance;
	end

	-- Create Party member frames
	for i = 1, #missionButtons do
		local button = missionButtons[i];
		button.Party = {}
		local partyMember = CreateFrame("Frame", nil, button, "MissionListPartyMemberPortrait")
		partyMember:SetPoint("LEFT", button.SuccessChance, "RIGHT", 20, 0);
		tinsert(button.Party, partyMember)
	end

	-- rewrite "Next" mission button as "Close"
	module:WatchOption("ListViewEnabled", function(option, value)
		local nextMissionButton = missionFrame.MissionComplete.NextMissionButton;
		nextMissionButton:SetText( value and CLOSE or NEXT )
	end)

	-- Clicking "Next" misison button closes the mission complete frame
	local nextMissionButton = GarrisonMissionFrame.MissionComplete.NextMissionButton
	nextMissionButton.OriginalOnClick = nextMissionButton:GetScript("OnClick")
	nextMissionButton:SetScript("OnClick", MissionMinder_MissionComplete_NextButton_CloseMissionComplete);

	-- Refresh completed missions list on GarrisonMissionFrame.MissionComplete:Hide
	--[[local events = MissionMinder.events;
	events:RegisterEvent("listview", "GARRISON_MISSION_COMPLETE_RESPONSE", refreshCompletedMissionsForQuickLoot);
	events:RegisterEvent("listview", "GARRISON_MISSION_BONUS_ROLL_COMPLETE", refreshCompletedMissionsForQuickLoot);
	GarrisonMissionFrame.MissionComplete:HookScript("OnHide", refreshCompletedMissions);

	-- Closing GarrisonMissionFrame should select the "Available Missions" tab. This will cause the next open to show
	--the completed missions dialog again (if applicable)
	GarrisonMissionFrame:HookScript("OnHide", selectAvailableMissions);

	-- Mission finished event should not show complete dialog if "In Progress" tab already selected
	-- Currently uses a pre-hook, with more work might be able to remove the pre-hook requirement and use secure post-hook
	addon.GarrisonMissionFrame_CheckCompleteMissions = GarrisonMissionFrame_CheckCompleteMissions;
	GarrisonMissionFrame_CheckCompleteMissions = showMissionCompleteFrame;]]
end
